/*
    ZEsarUX  ZX Second-Emulator And Released for UniX 
    Copyright (C) 2013 Cesar Hernandez Bano

    This file is part of ZEsarUX.

    ZEsarUX is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>


#include "divide.h"
#include "divmmc.h"
#include "diviface.h"
#include "cpu.h"
#include "debug.h"
#include "utils.h"

//z80_bit divide_enabled={0};

#define DIVIDE_ROM_NAME "esxide085.rom"
//#define DIVIDE_ROM_NAME "fatware-0-12a.bin"
//#define DIVIDE_ROM_NAME "demfird07b_E.bin"
//#define DIVIDE_ROM_NAME "mdos1_0.bin"
//#define DIVIDE_ROM_NAME "resi.bin"

z80_bit divide_ide_ports_enabled={0};
z80_bit divide_diviface_enabled={0};


/*void divide_enable(void)
{
	//Es excluyente con divmmc
	divmmc_diviface_disable();


	diviface_enable(DIVIDE_ROM_NAME);
        if (diviface_enabled.v) divide_enabled.v=1;

}

void divide_disable(void)
{

	diviface_disable();
        divide_enabled.v=0;
}
*/

void divide_ide_ports_enable(void)
{
        debug_printf (VERBOSE_INFO,"Enabling divide ide ports");
        divide_ide_ports_enabled.v=1;
}

void divide_ide_ports_disable(void)
{
        debug_printf (VERBOSE_INFO,"Disabling divide ide ports");
        divide_ide_ports_enabled.v=0;
}



//Activar solo la parte de paginacion cargando la rom de divide
void divide_diviface_enable(void)
{
        debug_printf (VERBOSE_INFO,"Enabling divide diviface ports");
        //Es excluyente con firmware de divmmc
        divmmc_diviface_disable();


        diviface_enable(DIVIDE_ROM_NAME);
        if (diviface_enabled.v) divide_diviface_enabled.v=1;
}

void divide_diviface_disable(void)
{
        debug_printf (VERBOSE_INFO,"Disabling divide diviface ports");
        diviface_disable();
        divide_diviface_enabled.v=0;
}

